/*
 * Vinyl widget:
 * Name: jSignature Vinyl Edit
 * Developer: Andrew Connor
 * Date: 3/23/2016
 */

define(function() {
  var install = function(holderElement, context) {
    var holderElement = holderElement.childNodes[0];
    var cell = context.getCell();
    var row = context.getRow();

    var color = context.getParameter("Color");
    var backgroundColor = context.getParameter("BackgroundColor");
    var lineWidth = parseInt(context.getParameter("LineWidth"));
    var height = parseInt(context.getParameter("Height"));
    var width = parseInt(context.getParameter("Width"));
    var imageFieldName = context.getParameter("ImageFieldName");
    console.log(imageFieldName);

    var imageCell = row.getCellByColumnName(imageFieldName);
    console.log(imageCell);

    var $signatureDiv = $(holderElement);

    //$("<style type='text/css'> .signature{ background-color:" + backgroundColor + "} </style>").appendTo("head");

    $signatureDiv.jSignature({
      color: color,
      lineWidth: lineWidth,
      height: height,
      width: width,
      cssclass: "signature",
      backgroundColor: "#7CFC00"
    });

    var canvas = holderElement.getElementsByTagName("canvas")[0];

    // From: http://stackoverflow.com/questions/32160098/change-html-canvas-black-background-to-white-background-when-creating-jpg-image
    // We are passing through the raw data, converting transparent pixels to white with no transparency...
    // We are currently doing this on every write to the cell, but probably only need to do it once...
    function canvasToImageTry2(canvas) {
      var context = canvas.getContext("2d");
      var w = canvas.width;
      var h = canvas.height;

      var imageData = context.getImageData(0, 0, w, h);
      var data = imageData.data;
      for (var i = 0; i < data.length; i += 4) {
        if (data[i + 3] < 255) {
          data[i] = 255;
          data[i + 1] = 255;
          data[i + 2] = 255;
          data[i + 3] = 255;
        }
      }
      context.putImageData(imageData, 0, 0);

      // This is out of jsignature...
      var imagestring = canvas.toDataURL();

      if (
        typeof imagestring === "string" &&
        imagestring.length > 4 &&
        imagestring.slice(0, 5) === "data:" &&
        imagestring.indexOf(",") !== -1
      ) {
        var splitterpos = imagestring.indexOf(",");

        imagestring = imagestring.substr(splitterpos + 1);
      } else {
        imagestring = null;
      }
      return imagestring;
    }

    function enableSignaturePad() {
      row.edit();
      $signatureDiv.jSignature("enable");
    }

    if (row.viewModel.isEditState() === false) {
      $signatureDiv.jSignature("disable");
      $signatureDiv.click(enableSignaturePad);
    }

    if (cell.value !== undefined && cell.value !== null && cell.value !== "") {
      $signatureDiv.jSignature(
        "setData",
        "data:image/jsignature;base30," + cell.value
      );
      console.log(imageCell);
      console.log($signatureDiv.jSignature("getData", "image"));
      //imageCell.value = canvasToImageTry2(canvas); // $signatureDiv.jSignature("getData","image")[1];
    }

    $signatureDiv.bind("change", function(e) {
      cell.value = $signatureDiv.jSignature("getData", "base30")[1];
      imageCell.value = canvasToImageTry2(canvas); // $signatureDiv.jSignature("getData","image")[1];
    });
  };

  var uninstall = function(holderElement, context) {
    var holderElement = holderElement.childNodes[0];
  };

  return {
    callbacks: {
      events: {
        // adding and removing
        install: install,
        uninstall: uninstall
      }
    }
  };
});
